import 'package:auto_size_text/auto_size_text.dart';
import 'package:flutter/material.dart';

class Button extends StatelessWidget {
    final String text;
    final Color backColor;
    final Color textColor;
    final TextAlign textAlign;
    final Function onPressed;

    Button(
        this.text,
        {
            this.backColor,
            this.textColor,
            this.textAlign = TextAlign.center,
            @required this.onPressed
        });

    @override
    Widget build(BuildContext context) {
        return Container(
            padding: EdgeInsets.all(3.0),
            child: ButtonTheme.bar(
                child: FlatButton(
                    materialTapTargetSize: MaterialTapTargetSize.shrinkWrap,
                    child: SizedBox(
                        width: double.infinity,
                        child: AutoSizeText(
                            text,
                            maxLines: 1,
                            textAlign: textAlign,
                            overflow: TextOverflow.ellipsis,
                            minFontSize: 8,
                        ),
                    ),
                    onPressed: onPressed,
                    color: backColor,
                    textColor: textColor,
                ),
            ),
        );
    }
}