import 'package:airbridge_flutter_sdk_example/basic/button_grid.dart';
import 'package:airbridge_flutter_sdk_example/storage.dart';
import 'package:flutter/material.dart';

import 'package:airbridge_flutter_sdk/airbridge.dart';

class IDSettingGrid extends StatefulWidget {
    @override
    State<StatefulWidget> createState() {
        return _State();
    }
}

class _State extends State<IDSettingGrid> {
    User user;

    @override
    void initState() {
        super.initState();

        user = Storage.get('user');
        user ?? setUserEmpty();

        setState(() {});
    }

    @override
    Widget build(BuildContext context) {
        return ButtonGrid(
            width: 3,
            backColor: Colors.green,
            textColor: Colors.white,
            datas: [
                ButtonData(user.id, (){}),
                ButtonData(user.email, (){}),
                ButtonData(user.phone, (){}),
                ButtonData('signIn', (){
                    setUser1();
                    Airbridge.event.send(SignInEvent(
                        user: user
                    ));
                }),
                ButtonData('signOut', (){
                    Airbridge.event.send(SignOutEvent());
                    setUserEmpty();
                }),
                ButtonData('signUp', (){
                    setUser1();
                    Airbridge.event.send(SignUpEvent(
                        user: user
                    ));
                }),
            ],
        );
    }

    void setUserEmpty() {
        user = User(
            id: '',
            email: '',
            phone: '',
        );
        Storage.set('user', user);
        setState(() {});
    }

    void setUser1() {
        user = User(
            id: 'test',
            email: 'test@ab180.co',
            phone: '000-0000-0000',
            alias: {
                'alias_key1': 'value1',
                'alias_key2': 'value2'
            },
            attributes: {
                'attributes_key2': 3,
                'attributes_key5': 2200000000,
                'attributes_key4': 10.4,
                'attributes_key3': true,
                'attributes_key1': 'value1'
            }
        );
        Storage.set('user', user);
        setState(() {});
    }
}