import 'package:airbridge_flutter_sdk_example/app.dart';
import 'package:airbridge_flutter_sdk_example/storage.dart';
import 'package:flutter/material.dart';

import 'data/log_item.dart';

import 'package:airbridge_flutter_sdk/airbridge.dart';
import 'package:airbridge_flutter_sdk/src/util/log.dart' as AB;

void main() {
    runApp(App());
    init();
}

Future<void> init() async {
    AB.Log.addOnLog((message) {
        List<LogItem> logs = Storage.get('logs');
        if (logs == null) {
            logs = List();
        }

        logs.add(LogItem(
            DateTime.now(),
            message
        ));

        Storage.set('logs', logs);
    });

    Airbridge.deeplink.setDeeplinkListener((deeplink) {
        Storage.set('deeplink', deeplink);
    });

    Storage.set('user', User(
        id: 'test',
        email: 'test@ab180.co',
        phone: '000-0000-0000',
        alias: {
            'alias_key1': 'value1',
            'alias_key2': 'value2'
        },
        attributes: {
            'attributes_key2': 3,
            'attributes_key5': 2200000000,
            'attributes_key4': 10.4,
            'attributes_key3': true,
            'attributes_key1': 'value1'
        }
    ));

    Storage.set('sessionTimeout', 15000);
    Storage.set('deeplinkFetchTimeout', 3000);
    Storage.set('isTrackingAirbridgeDeeplinkOnly', false);
    Storage.set('isTrackingEnabled', true);
    Storage.set('isUserInfoHashed', true);

    Storage.set('deviceUUID', await Airbridge.state.deviceUUID);
    
    AB.Log.info('init');
}