class Storage {
    static Map<String, dynamic> _map = Map();
    static Map<String, List<Function>> _onSets = Map();

    static void set<T>(String key, T object) {
        if (_onSets[key] != null) {
            _onSets[key].forEach((function) => function(object));
        }

        _map[key] = object;
    }

    static T get<T>(String key) {
        return _map[key];
    }

    static addOnSet(String key, Function callback) {
        if (_onSets[key] == null) {
            _onSets[key] = List();
        }

        _onSets[key].add(callback);
    }

    static removeOnSet(String key, Function callback) {
        if (_onSets[key] == null) {
            return;
        }

        _onSets[key].remove(callback);
    }
}