#import "AirbridgeFL.h"

#import "AFLGet.h"
#import "AFLConfigReader.h"
#import "AFLDeeplinkAPI.h"
#import "AFLEventAPI.h"
#import "AFLStateAPI.h"
#import "AFLPlacementAPI.h"

// Airbridge
#import <AirBridge/AirBridge.h>
#import <AirBridge/ABDeeplink.h>

@implementation AirbridgeFL

static AirbridgeFL* instance;

//
// flutter plugin setting
//

+ (void) registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    [AFLDeeplinkAPI registerWithRegistrar:registrar];
    [AFLEventAPI registerWithRegistrar:registrar];
    [AFLStateAPI registerWithRegistrar:registrar];
    [AFLPlacementAPI registerWithRegistrar:registrar];
}

//
// init
//

+ (nullable AirbridgeFL*)instance {
    return instance;
}

+ (AirbridgeFL*) getInstance:(NSString *)appToken
                     appName:(NSString *)appName
           withLaunchOptions:(NSDictionary *)launchOptions
{
    [AFLConfigReader apply];

    [AirBridge getInstance:appToken appName:appName withLaunchOptions:launchOptions];
    [AFLDeeplinkAPI setInitialDeeplinkCallback];
    
    if (instance != nil) {
        instance = [[AirbridgeFL alloc] init];
    }
    
    return instance;
}

//
// interface
//

+ (ABState*)state {
    return AirBridge.state;
}

+ (ABDeeplink*)deeplink {
    return AirBridge.deeplink;
}

@end
