import 'dart:collection';

import '../data/event_option.dart';
import '../data/product.dart';
import '../event/event.dart';

class AddToCartEvent extends Event {

    static const String CATEGORY = 'airbridge.ecommerce.product.addedToCart';

    String cartID;
    List<Product> products;
    String currency;
    num totalValue;
    num totalQuantity;

    AddToCartEvent({
        this.cartID,
        this.products,
        this.currency,
        this.totalValue,
        this.totalQuantity,
        EventOption option
    }) : super(CATEGORY, option: option);

    @override
    Map<String, dynamic> toMap() {
        if (option == null) {
            option = EventOption();
        }

        if (option?.semantics == null) {
            option.semantics = {};
        }

        option?.semantics['cartID'] = cartID;
        option?.semantics['products'] = products?.map((product) => product.toMap())?.toList();
        option?.semantics['currency'] = currency;
        option?.semantics['totalValue'] = totalValue;
        option?.semantics['totalQuantity'] = totalQuantity;

        return {
            'category': category,
            'option': option?.toMap()
        };
    }
}