import '../data/product.dart';
import '../event/event.dart';
import '../data/event_option.dart';

class PurchaseEvent extends Event {
    static const String CATEGORY = 'airbridge.ecommerce.order.completed';

    String transactionID;
    List<Product> products;
    bool isInAppPurchase;
    String currency;
    num totalValue;
    num totalQuantity;

    PurchaseEvent({
        this.transactionID,
        this.products,
        this.isInAppPurchase,
        this.currency,
        this.totalValue,
        this.totalQuantity,
        EventOption option
    }) : super(CATEGORY, option: option);

    @override
    Map<String, dynamic> toMap() {
        if (option == null) {
          option = EventOption();
        }

        if (option?.semantics == null) {
          option.semantics = {};
        }

        option?.semantics['transactionID'] = transactionID;
        option?.semantics['products'] = products?.map((product) => product.toMap())?.toList();
        option?.semantics['inAppPurchased'] = isInAppPurchase;
        option?.semantics['currency'] = currency;
        option?.semantics['totalValue'] = totalValue;
        option?.semantics['totalQuantity'] = totalQuantity;

        return {
            'category': category,
            'option': option?.toMap()
        };
    }
}