import '../data/event_option.dart';
import '../data/product.dart';
import '../event/event.dart';

class ViewProductDetailEvent extends Event {
    static const String CATEGORY = 'airbridge.ecommerce.product.viewed';

    List<Product> products;

    ViewProductDetailEvent({
        this.products,
        EventOption option
    }) : super(CATEGORY, option: option);

    @override
    Map<String, dynamic> toMap() {
        if (option == null) {
            option = EventOption();
        }

        if (option?.semantics == null) {
            option.semantics = {};
        }

        option?.semantics['products'] = products?.map((product) => product.toMap())?.toList();

        return {
            'category': category,
            'option': option?.toMap(),
        };
    }
}