import '../data/product.dart';
import '../data/event_option.dart';
import '../event/event.dart';

class ViewProductListEvent extends Event {
    static const String CATEGORY = 'airbridge.ecommerce.productList.viewed';

    String listID;
    List<Product> products;

    ViewProductListEvent({this.listID,
        this.products,
        EventOption option})
        : super(CATEGORY, option: option);

    @override
    Map<String, dynamic> toMap() {
        if (option == null) {
            option = EventOption();
        }

        if (option?.semantics == null) {
            option.semantics = {};
        }

        option?.semantics['productListID'] = listID;
        option?.semantics['products'] = products?.map((product) => product.toMap())?.toList();

        return {
            'category': category,
            'option': option?.toMap()
        };
    }
}