import '../data/product.dart';
import '../data/event_option.dart';
import '../event/event.dart';

class ViewSearchResultEvent extends Event {
    static const String CATEGORY = 'airbridge.ecommerce.searchResults.viewed';

    String query;
    List<Product> products;

    ViewSearchResultEvent({this.query,
                            this.products,
                            EventOption option})
        : super(CATEGORY, option: option);

    @override
    Map<String, dynamic> toMap() {
        if (option == null) {
            option = EventOption();
        }

        if (option?.semantics == null) {
            option.semantics = {};
        }

        option?.semantics['query'] = query;
        option?.semantics['products'] = products?.map((product) => product.toMap())?.toList();

        return {
            'category': category,
            'option': option?.toMap()
        };
    }
}