import '../util/log.dart';
import 'package:flutter/services.dart';

class DeeplinkAPI {
    final EventChannel _deeplinkEvent;

    Function _deeplinkListener;

    String _initialDeeplink;

    DeeplinkAPI(this._deeplinkEvent) {
        _deeplinkListener = (deeplink) {
            _initialDeeplink = deeplink;
        };

        _deeplinkEvent
            .receiveBroadcastStream("deeplink")
            .listen((deeplink) {
                Log.info('$deeplink [deeplink]');

                _deeplinkListener(deeplink);
            });
    }

    void setDeeplinkListener(Function listener) {
        Log.info('set deeplink listener');

        if (_initialDeeplink != null) {
            listener(_initialDeeplink);
            _initialDeeplink = null;
        }

        this._deeplinkListener = listener;
    }
}
