import '../util/log.dart';
import 'package:flutter/services.dart';

class PlacementAPI {
    final MethodChannel _method;

    PlacementAPI(this._method);

    void click(String trackingLink, [String deeplink, String fallback]) {
        Log.info('click $trackingLink');

        _method.invokeMethod('click', {
            'trackingLink': trackingLink,
            'deeplink': deeplink,
            'fallback': fallback,
        });
    }

    void impression(String trackingLink) {
        Log.info('impression $trackingLink');

        _method.invokeMethod('impression', {
            'trackingLink': trackingLink,
        });
    }
}
