import '../data/user.dart';
import '../util/log.dart';
import 'package:flutter/services.dart';

class StateAPI {
    final MethodChannel _method;

    StateAPI(this._method);

    void setUser(User user) {
        Log.info('set user');

        if (user == null) {
            Log.isNull('user');
            Log.fail('set user');
            return;
        }

        _method.invokeMethod('setUser', user.toMap());
    }

    void updateUser(User user) {
        Log.info('update user');

        if (user == null) {
            Log.isNull('user');
            Log.fail('update user');
            return;
        }

        _method.invokeMethod('updateUser', user.toMap());
    }

    void startTracking() {
        Log.info('start tracking');

        _method.invokeMethod('startTracking');
    }

    Future<String> get deviceUUID async {
        Log.info('get device uuid');

        return _method.invokeMethod('getDeviceUUID', null);
    }
}
